#include "../keyboard.h"
#define NIL '\0'
#define BKS '\x8'
#define ENT '\n'
#define CPS KEYBOARD_CAPS
#define SHF KEYBOARD_SHIFT
#define CAN KEYBOARD_CANCEL
#define ESC KEYBOARD_ESCAPE
#define F1_ KEYBOARD_F1
#define F2_ KEYBOARD_F2
#define F3_ KEYBOARD_F3
#define F4_ KEYBOARD_F4
#define F5_ KEYBOARD_F5
#define F6_ KEYBOARD_F6
#define F7_ KEYBOARD_F7
#define F8_ KEYBOARD_F8
#define F9_ KEYBOARD_F9
#define F10 KEYBOARD_F10
#define F11 KEYBOARD_F11
#define F12 KEYBOARD_F12
#define CTL KEYBOARD_CTRL
#define ALT KEYBOARD_ALT
#define WIN KEYBOARD_WINDOWS

const char keyboard_qwerty[3][16][32] =
{
	{
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,ESC,ESC,NIL,F1_,F1_,F2_,F2_,F3_,F3_,F4_,F4_,F5_,F5_,F6_,F6_,F7_,F7_,F8_,F8_,F9_,F9_,F10,F10,F11,F11,F12,F12,NIL,CAN,CAN,NIL},
		{NIL,ESC,ESC,NIL,F1_,F1_,F2_,F2_,F3_,F3_,F4_,F4_,F5_,F5_,F6_,F6_,F7_,F7_,F8_,F8_,F9_,F9_,F10,F10,F11,F11,F12,F12,NIL,CAN,CAN,NIL},
		{NIL,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','-','-','+','+',BKS,BKS,BKS,BKS,NIL,NIL,NIL},
		{NIL,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','-','-','+','+',BKS,BKS,BKS,BKS,NIL,NIL,NIL},
		{NIL,NIL,'q','q','w','w','e','e','r','r','t','t','y','y','u','u','i','i','o','o','p','p','[','[',']',']','\\','\\',NIL,NIL,NIL,NIL},
		{NIL,NIL,'q','q','w','w','e','e','r','r','t','t','y','y','u','u','i','i','o','o','p','p','[','[',']',']','\\','\\',NIL,NIL,NIL,NIL},
		{NIL,CPS,CPS,'a','a','s','s','d','d','f','f','g','g','h','h','j','j','k','k','l','l',';',';','\'','\'',ENT,ENT,ENT,ENT,NIL,NIL,NIL},
		{NIL,CPS,CPS,'a','a','s','s','d','d','f','f','g','g','h','h','j','j','k','k','l','l',';',';','\'','\'',ENT,ENT,ENT,ENT,NIL,NIL,NIL},
		{NIL,SHF,SHF,SHF,'z','z','x','x','c','c','v','v','b','b','n','n','m','m',',',',','.','.','/','/',SHF,SHF,SHF,NIL,NIL,NIL,NIL,NIL},
		{NIL,SHF,SHF,SHF,'z','z','x','x','c','c','v','v','b','b','n','n','m','m',',',',','.','.','/','/',SHF,SHF,SHF,NIL,NIL,NIL,NIL,NIL},
		{NIL,CTL,CTL,WIN,WIN,ALT,ALT,'`','`',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,CTL,CTL,WIN,WIN,ALT,ALT,'`','`',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL}
	},
	{
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,ESC,ESC,NIL,F1_,F1_,F2_,F2_,F3_,F3_,F4_,F4_,F5_,F5_,F6_,F6_,F7_,F7_,F8_,F8_,F9_,F9_,F10,F10,F11,F11,F12,F12,NIL,CAN,CAN,NIL},
		{NIL,ESC,ESC,NIL,F1_,F1_,F2_,F2_,F3_,F3_,F4_,F4_,F5_,F5_,F6_,F6_,F7_,F7_,F8_,F8_,F9_,F9_,F10,F10,F11,F11,F12,F12,NIL,CAN,CAN,NIL},
		{NIL,'!','!','@','@','#','#','$','$','%','%','^','^','&','&','*','*','(','(',')',')','_','_','+','+',BKS,BKS,BKS,BKS,NIL,NIL,NIL},
		{NIL,'!','!','@','@','#','#','$','$','%','%','^','^','&','&','*','*','(','(',')',')','_','_','+','+',BKS,BKS,BKS,BKS,NIL,NIL,NIL},
		{NIL,NIL,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P','{','{','}','}','\\','\\',NIL,NIL,NIL,NIL},
		{NIL,NIL,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P','{','{','}','}','\\','\\',NIL,NIL,NIL,NIL},
		{NIL,CPS,CPS,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',':',':','"','"',ENT,ENT,ENT,ENT,NIL,NIL,NIL},
		{NIL,CPS,CPS,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',':',':','"','"',ENT,ENT,ENT,ENT,NIL,NIL,NIL},
		{NIL,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M','<','<','>','>','?','?',SHF,SHF,SHF,NIL,NIL,NIL,NIL,NIL},
		{NIL,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M','<','<','>','>','?','?',SHF,SHF,SHF,NIL,NIL,NIL,NIL,NIL},
		{NIL,CTL,CTL,WIN,WIN,ALT,ALT,'~','~',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,CTL,CTL,WIN,WIN,ALT,ALT,'~','~',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL}
	},
	{
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,ESC,ESC,NIL,F1_,F1_,F2_,F2_,F3_,F3_,F4_,F4_,F5_,F5_,F6_,F6_,F7_,F7_,F8_,F8_,F9_,F9_,F10,F10,F11,F11,F12,F12,NIL,CAN,CAN,NIL},
		{NIL,ESC,ESC,NIL,F1_,F1_,F2_,F2_,F3_,F3_,F4_,F4_,F5_,F5_,F6_,F6_,F7_,F7_,F8_,F8_,F9_,F9_,F10,F10,F11,F11,F12,F12,NIL,CAN,CAN,NIL},
		{NIL,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','-','-','+','+',BKS,BKS,BKS,BKS,NIL,NIL,NIL},
		{NIL,'1','1','2','2','3','3','4','4','5','5','6','6','7','7','8','8','9','9','0','0','-','-','+','+',BKS,BKS,BKS,BKS,NIL,NIL,NIL},
		{NIL,NIL,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P','[','[',']',']','\\','\\',NIL,NIL,NIL,NIL},
		{NIL,NIL,'Q','Q','W','W','E','E','R','R','T','T','Y','Y','U','U','I','I','O','O','P','P','[','[',']',']','\\','\\',NIL,NIL,NIL,NIL},
		{NIL,CPS,CPS,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',';',';','\'','\'',ENT,ENT,ENT,ENT,NIL,NIL,NIL},
		{NIL,CPS,CPS,'A','A','S','S','D','D','F','F','G','G','H','H','J','J','K','K','L','L',';',';','\'','\'',ENT,ENT,ENT,ENT,NIL,NIL,NIL},
		{NIL,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M',',',',','.','.','/','/',SHF,SHF,SHF,NIL,NIL,NIL,NIL,NIL},
		{NIL,SHF,SHF,SHF,'Z','Z','X','X','C','C','V','V','B','B','N','N','M','M',',',',','.','.','/','/',SHF,SHF,SHF,NIL,NIL,NIL,NIL,NIL},
		{NIL,CTL,CTL,WIN,WIN,ALT,ALT,'`','`',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,CTL,CTL,WIN,WIN,ALT,ALT,'`','`',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL},
		{NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL,NIL}
	}
};

//{NIL,'!','!','@','@','#','#','$','$','%','%','^','^','&','&','*','*','(','(',')',')','_','_','+','+',NIL,BKS,BKS,BKS,NIL,NIL,NIL},
//{NIL,'!','!','@','@','#','#','$','$','%','%','^','^','&','&','*','*','(','(',')',')','_','_','+','+',NIL,BKS,BKS,BKS,NIL,NIL,NIL},
